<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { NextStep } from '~/components/common/index.vue';
import { MenuComponent as SideMenu } from '~/components/side-menu/index.vue';
import {
  TopicsCards,
  AnchorDropdown,
  StagesDevopsLifeCycleCTA as CallToAction,
  CopyMedia,
} from '~/components/stages-devops-lifecycle/index.vue';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful';

export default Vue.extend({
  name: 'StagesDevopsLifecycle',
  components: {
    SideMenu,
    CallToAction,
    AnchorDropdown,
    CopyMedia,
    TopicsCards,
    NextStep,
  },
  nuxtI18n: false,
  async asyncData() {
    try {
      const client = getClient();
      let contentful = await client.getEntries({
        'fields.slug': '/stages-devops-lifecycle/',
        content_type: CONTENT_TYPES.PAGE,
        include: 2,
      });
      contentful = contentful.items[0].fields;

      const seo = contentful.seoMetadata[0].fields;
      const { pageContent } = contentful;
      const copy_medias = pageContent
        .filter((entry) => entry.sys.contentType.sys.id === CONTENT_TYPES.CARD)
        .map((entry) => entry.fields);

      const topics_cards = pageContent
        .filter(
          (entry) => entry.sys.contentType.sys.id === CONTENT_TYPES.CARD_GROUP,
        )
        .map((entry) => entry.fields.card)[0]
        .map((entry) => entry.fields);

      const doc = {
        side_menu: {
          links: copy_medias.map((stage) => ({
            text: stage.title,
            href: `#${stage.title.toLowerCase()}`,
            data_ga_name: stage.title.toLowerCase(),
            data_ga_location: 'header',
          })),
          placeholder: 'Select a stage',
        },
        call_to_action: {
          title: pageContent[0].fields.title,
          subtitle: pageContent[0].fields.subheader,
          body_text: pageContent[0].fields.description,
          horizontal_rule: true,
        },
        copy_medias: copy_medias.map((stage, index) => ({
          block: [
            {
              header: stage.title,
              icon: {
                name: stage.iconName,
                alt: '',
                variant: 'marketing',
              },
              subtitle: stage.subtitle,
              text: stage.description,
              image: {
                image_url: stage.image.fields.file.url,
                image_alt: stage.title,
              },
              link_href: stage.cardLink,
              link_text: 'Learn more →',
              link_variant: 'text',
              inverted: index % 2 === 0,
              metadata: {
                id_tag: stage.title.toLowerCase(),
              },
            },
          ],
        })),
        topics_cards: {
          cards: topics_cards.map((card) => ({
            category: card.subtitle.toUpperCase(),
            title: card.title,
            description: card.description,
            icon: {
              name: card.iconName,
              alt: '',
              variant: 'marketing',
            },
            url: card.cardLink,
            data_ga_name: card.cardLinkDataGaName,
            data_ga_location: card.cardLinkDataGaLocation,
          })),
        },
      };

      return { seo, doc };
    } catch (e) {
      // eslint-disable-next-line no-console
      console.error({ message: e });
    }
    return null;
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).seo, this.$route.path);
  },
  mounted() {
    const { sideMenu } = this.$refs;
    document.addEventListener('scroll', () => {
      if (window.scrollY >= 5550.5) {
        sideMenu.$el.style.display = 'none';
      } else sideMenu.$el.style.display = 'block';
    });
  },
});
</script>
<template>
  <SlpContainer class="stages-devops">
    <SlpRow class="row">
      <SlpColumn :cols="10" size="xl">
        <CallToAction :data="doc.call_to_action" />
        <div class="stages">
          <AnchorDropdown
            fixed
            :options="doc.side_menu.links"
            :placeholder="doc.side_menu.placeholder"
          />
          <div ref="copyContainer">
            <CopyMedia
              v-for="contentBlock in doc.copy_medias"
              :key="contentBlock.header"
              :data="contentBlock"
            />
          </div>
        </div>
      </SlpColumn>
      <SideMenu
        v-if="doc.side_menu"
        ref="sideMenu"
        :links="doc.side_menu.links"
      />
      <TopicsCards :data="doc.topics_cards" />
      <NextStep />
    </SlpRow>
  </SlpContainer>
</template>

<style scoped lang="scss"></style>
